module.exports.parse=function(str,reviver){
  if (str.length>0 && str[0]==='{'){
    var curlydepth=1;
    var inquotes=false;
    for (var i=1; i<str.length; i++) {
      if (inquotes==false) {
        if (str[i]=='{') {
          curlydepth++;
        } else if (str[i]=='}') {
          curlydepth--;
        } else if (str[i]=='"') {
          inquotes=true;
          continue;
        };
      } else if (str[i]=='"' && "\\\""!==str[i-1]+str[i]) {
        inquotes=false;
        continue;
      };
      if (curlydepth==0) {
        var headerstr=str.substring(0,i+1);
        var bodystr=str.substring(i+1);
        try {
          var headerobj=JSON.parse(headerstr,reviver);
        } catch (e) {
          //apparenty the header isn't valid JSON... return entire str as body
          return {header:null,body:str};
        };
        if (bodystr.length>0 && bodystr[0]==="\n") {
          bodystr=bodystr.substring(1);
        };
        return {header:headerobj,body:bodystr};
      };
    };
  };
  return {header:null,body:str};
};

module.exports.dateReviver=function(key,value){
  if (key==="date") {
    value=new Date(value);
  };
  return value;
};

module.exports.stringify=function(header,body,replacer,space){
  if (space!==undefined) {
    var sp=space;
  } else {
    var sp=2;
  };
  var result=JSON.stringify(header,replacer,sp);
  result=result+"\n"+body;
  return result;
};
