var expect=require('expect.js');
var jh=require('../index.js');

describe("parse", function() {
  it("should parse JSON", function() {
    var str='{"testkey":"testval"}\ntestbody';
    var parsed=jh.parse(str);
    expect(parsed.body).to.be.eql("testbody");
    expect(parsed.header).to.be.eql({testkey:"testval"});
  });
  it("should get the date out when asked", function() {
    var str='{"date":"2013-01-24 CST"}\ntestbody';
    var parsed=jh.parse(str,jh.dateReviver);
    expect(parsed.header.date).to.be.a('object');
    expect(parsed.header.date.getTime()).to.be.eql(1359007200000);
  });
  it("should not return a header", function() {
    var str="{{{}}body";
    var parsed=jh.parse(str);
    expect(parsed.header).to.be.eql(null);
    expect(parsed.body).to.be.eql(str);
  });
  it ("should not fail on quotes in header", function() {
    var str='{"test":"{"}body';
    var parsed=jh.parse(str);
    expect(parsed.header).to.be.eql({"test":"{"});
    expect(parsed.body).to.be.eql("body");
  });
});

describe("stringify", function() {
  it("should make a string", function() {
    var myvar=jh.parse('{"test":"test"}body}');
    var mystr=jh.stringify(myvar.header,myvar.body);
    expect(mystr).to.be.eql('{\n  "test": "test"\n}\nbody}');
  });
});

